import ZSyncer
import zLOG
from Config import sync_tab_classes
from ConfigUtils import _import, _addSyncTab


# try to import CMF, if so
# try to import ZSyncerTool, otherwise
# dont bother ;)
try:
    from Products.CMFCore import utils
    CMF = 1
    zLOG.LOG('ZSyncer', 0, 'have CMF, will set up ZSyncerTool')
    from ZSyncerTool import ZSyncerTool
except ImportError:
    CMF = 0
    zLOG.LOG('ZSyncer', 0, 'no CMF found, cannot set up ZSyncerTool')


# helps with installation of CMF tool
zs_globals = globals()

def initialize(context): 
    context.registerClass(
            ZSyncer.ZSyncer, 
            constructors = (ZSyncer.manage_addZSyncerForm,
                            ZSyncer.manage_addZSyncer), 
            icon='zsyncer_icon.gif')
    context.registerHelp()
    
    if CMF:
        from Products.CMFCore.DirectoryView import registerDirectory
        registerDirectory('skins', zs_globals)
        from ZSyncerTool import ZSyncerTool
        utils.ToolInit(ZSyncerTool.meta_type, 
                       tools=(ZSyncerTool, ),
                       product_name='ZSyncer',  # NOT meta_type!
                       icon='zsyncer_icon.gif', # must be in this directory.
                       ).initialize( context )
        # You still have to call the installer external method
        # in the context of your CMF site.

# MONKEY PATCH!
# Oh, for a skinnable ZMI. Some day my zope 3 will come.
# ok rummage through all the items to 
# import, Folder.manage_options is one, but
# if you have custom folderish objects add them to Config.py 

for modpath, classname in sync_tab_classes:
    if classname == 'ZObject':
        isZObject=1
    else:
        isZObject=0
    # do the import...
    try:
        klass = _import(modpath, classname)
        # Got the class, now add the tab
        _addSyncTab(klass, isZObject)
    except ImportError:
        zLOG.LOG('ZSyncer', 100, 'Failed to add tab to %s, %s' % (
            modpath, classname)
                 )
        continue

